//hyp.data.test.cpp
//creation 18/03/01 Tycho

#include"hyp.test.h"

std::ostream& __show_vertices(std::ostream& stream,hyp_common::IContainerKey* p_cont,bool b_show_coord)
{
	hyp_common::t_spContainerKey spIContKey=p_cont;
	hyp_common::t_spContainerIterator spIContItor=spIContKey;
	hyp_common::t_spContainer spICont=spIContKey;

	stream<<"->("<<spICont->GetSize()<<")\n";

	hyp_data::t_spGeometricVertex spIVertex;
	spIVertex=spIContItor->SetBeginSelection();

	try {
		while(1) {
		stream<<"N-"<<spIContKey->GetKey(spIVertex)<<"\t";
		if(b_show_coord) {
			stream<<spIVertex->GetCoord(0)<<","
				  <<spIVertex->GetCoord(1)<<","
				  <<spIVertex->GetCoord(2)<<"\n";
		}
		spIVertex=spIContItor->IncrSelection();
		}
	} catch(...) {
		stream<<"<-\n";
	}

	return stream;
}

std::ostream& __show_elements(std::ostream& stream,hyp_fem::IFEOMesh* p_mesh)
{
	hyp_common::t_spContainerKey spIContKey;
	spIContKey=p_mesh->GetContainerOfElements();
	
	hyp_common::t_spContainerIterator spIContItor=spIContKey;
	hyp_common::t_spContainer spICont=spIContKey;

	stream<<"->("<<spICont->GetSize()<<")\n";
	
	hyp_data::t_spGeometricBase spIBase_Element;
	
	try {
		spIBase_Element=spIContItor->SetBeginSelection();
		int i=0;
		while(1) {
			stream<<"S-"<<i<<'\n';
			i++;//spIContKey->GetKey(spIBase_Element)<<"\t";
		
			hyp_common::t_spContainerIterator spIContItorV=
				spIBase_Element->GetContainerOfVertices();
			try {
				hyp_data::t_spGeometricVertex spIVertex=spIContItorV->SetBeginSelection();
				while(1) {
					hyp_data::t_spGeometricBase spIBase_Mesh=p_mesh;
					stream<<spIBase_Mesh->GetLabel(spIVertex)<<" ";
					spIVertex=spIContItorV->IncrSelection();
				}
			} catch(...) {
			stream<<"<-\n";
			}
		spIBase_Element=spIContItor->IncrSelection();
		}
	} catch(hyp_ker::CComError error) {
		stream<<"<-\n";
	}

	return stream;
}

std::ostream& operator<<(std::ostream& stream,hyp_fem::IFEOMesh* p_mesh)
{
	hyp_common::t_spContainerKey spIContKey;
	hyp_common::t_spContainerIterator spIContItor;
	hyp_common::t_spContainer spICont;

	stream<<"Vertices\n";
	hyp_data::t_spGeometricBase sp_IBase_Mesh=p_mesh;
	spIContKey=sp_IBase_Mesh->GetContainerOfVertices();
	__show_vertices(stream,spIContKey,true);
	
	stream<<"Elements\n";
	__show_elements(stream,p_mesh);
	
	return stream;
}


void TestGeometricObjects(void)
{
	const hyp::t_real a=10;
	const hyp::t_real b=20;
	const hyp::t_real c=30;

	const int d_a=5;
	const int d_b=5;
	const int d_c=5;
	
	
	hyp_data::t_spGeometricSide sp_ISide;
	hyp_data::t_spGeometricObject sp_IObject;
	hyp_fem::t_spFEOMesh sp_IMesh;
	hyp_data::t_spGeometricVertex sp_IVertex;
	
	
	//on fait un cube
	try{
	//smart-pointeur


	//divers
	hyp::t_label i=0;
	hyp::t_enum_label e;

	
	//creation de l'objet

	sp_IObject.CreateInstance(hyp_fem::CLSID_hypCFEOMesh,0);
	hyp_data::t_spGeometricBase sp_IBase_Mesh=sp_IObject;
	sp_IMesh=sp_IObject;
	

	//nodes
	hyp::t_real xi,yi,zi;
	i=0;
	//au niveau z=0
	for(xi=0;xi<=a;xi+=a/d_a) {
		for(yi=0;yi<=b;yi+=b/d_b) {
			for(zi=0;zi<=c;zi+=c/d_c) {
				sp_IObject->CreateVertex(i,xi,yi,zi);
				i++;
			}
		}
	}

	//hyp_ker::hyp_clog<<sp_IMesh;

	hyp_common::IContainerKey* p_cont_key=sp_IBase_Mesh->GetContainerOfVertices();
	hyp_ker::hyp_clog<<p_cont_key;

	hyp_ker::t_spSerialize spSerialize=sp_IMesh;
	spSerialize->UnSerialize(std::string("c:\\test_serialize.x"));

/*
	//creation des lments
	//noter le strictement '<'
	i=0;
	for(xi=0;xi<a;xi+=a/d_a) {
		for(yi=0;yi<b;yi+=b/d_b) {
			for(zi=0;zi<c;zi+=c/d_c) {
				sp_IVertex=sp_IBase_Mesh->GetVertex(xi,yi,zi);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));
		
				sp_IVertex=sp_IBase_Mesh->GetVertex(xi+a/d_a,yi,zi);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));

				sp_IVertex=sp_IBase_Mesh->GetVertex(xi+a/d_a,yi+b/d_b,zi);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));

				sp_IVertex=sp_IBase_Mesh->GetVertex(xi,yi+b/d_b,zi);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));

				sp_IVertex=sp_IBase_Mesh->GetVertex(xi,yi,zi+c/d_c);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));

				sp_IVertex=sp_IBase_Mesh->GetVertex(xi+a/d_a,yi,zi+c/d_c);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));

				sp_IVertex=sp_IBase_Mesh->GetVertex(xi+a/d_a,yi+b/d_b,zi+c/d_c);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));

				sp_IVertex=sp_IBase_Mesh->GetVertex(xi,yi+b/d_b,zi+c/d_c);
				e.push_back(sp_IBase_Mesh->GetLabel(sp_IVertex));

				sp_IMesh->CreateElement(i,e);
				e.clear();
				i++;

			}
		}
	}

	hyp_ker::hyp_clog<<sp_IMesh;

	hyp_common::t_spContainerKey spContainer_Elements;
	spContainer_Elements=sp_IMesh->GetContainerOfElements();
	hyp_ker::hyp_clog<<spContainer_Elements;

	hyp_data::t_spGeometricBase spGeoBase_Element;
	spGeoBase_Element=spContainer_Elements->GetContent(1);
	hyp_common::t_spContainerKey spContainer_Nodes=spGeoBase_Element->GetContainerOfVertices();
	__show_vertices(std::cout,spContainer_Nodes,true);
*/
	




	} catch(...) {
		std::cout<<"error";
		return;
	}	
}

/*
void TestLoading(void)
{
	t_Object spIObject;
	spIObject.CreateInstance(hyp_data::CLSID_hypCGeometricObject,0);
	t_File spIFile=spIObject;
	const char* path="G:\\works\\hyperion\\hypvisualc\\hyptest\\cube_t.x";
	
	spIFile->UnSerialize(std::string(path));

	std::cout<<spIObject;
}
*/

