/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypDev.
 HypDev is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

class CDevMesh
{
public:
	CDevMesh(std::ostream& Stream) : m_Stream(Stream) { };
	~CDevMesh();
	
	void Generation(const t_real& , const t_real& ,const t_real& ,
							const int& ,const int& ,const int& );
	void InitMesh(hyp_ker::IUnknown*);
	void CreateMesh(void);
	void Construct(void);	 
	
	void ShowMesh(const std::string&);
	void SaveMesh(const std::string&);
	void SaveDisplayFile(const std::string&);

	void LoadMesh(const std::string&);

	void SetDOF(const t_real&,const t_real&,const t_real&,
		bool,bool,bool,
		bool,bool,bool);

	void SetForce(const t_real&,const t_real&,const t_real&,
		bool,bool,bool,
		const t_real&,const t_real&,const t_real&);

	void Solve(void);
/*
	struct Chrono {
		Chrono();
		~Chrono();
	private:
		hyp_ker::WF_Profiler m_Profiler;
	};
	*/
private:
	void CreateSide(const t_real&,const t_real&,const t_real&,
				const t_size&,const t_size&,const t_size&,t_label&);


	hyp_ker::IPtrUnknown m_spUnknownMesh;
	hyp_fem::t_spGeometricBase m_spBaseMesh;
	hyp_fem::t_spGeometricObject m_spObjectMesh;
	hyp_fem::t_spFEOMesh m_spMeshMesh;

	std::ostream& m_Stream;
};