/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypDev.
 HypDev is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

class CArgData
{
protected:
	static int m_Argc;
	static char** m_Argv;
	static void SetArg(int Argc,char** Argv) { m_Argc=Argc; m_Argv=Argv; }
};

template<class T>
class CData :
protected CArgData
{
public:
	virtual int GetSize(void) const =0;
	virtual T GetValue(int) const =0;
};


class CLabel :
public CData<std::string>
{
	int m_PosBegin;		//postion du label
	int m_PosLast;	//position du label suivant
public:
	CLabel(int =0,int =0);
	virtual int GetSize(void) const;
	virtual std::string GetValue(int) const;

	template<class T>
	void Get(T& Value,int Pos) const {
		std::stringstream str_stream;
		str_stream<<GetValue(Pos);
		str_stream>>Value;
	}
};

class CMainParameters;
typedef std::vector<CLabel> t_LabelEnum;

class CLabelEnum :
public CData<CLabel>,
public t_LabelEnum
{
	std::string m_LabelName;
public:
	CLabelEnum(const std::string& LabelName) : m_LabelName(LabelName) { }
	virtual int GetSize(void) const;
	virtual CLabel GetValue(int) const;

	std::string GetLabelName(void) const { return m_LabelName; }	
};

class CMainParameters :
public CData<CLabelEnum>
{
	const char m_LabelKey;
	
public:
	CMainParameters(int,char**,char);
	virtual int GetSize(void) const;
	virtual CLabelEnum GetValue(int) const;	
	std::string GetModuleFileName(void) const;
	std::string GetModulePath(void) const;
	std::string GetModuleName(void) const;
	std::string GetLineOfParameters(void) const;

private:
	int GetNextLabelPosition(int) const;
	std::string GetLabelName(int) const;
	int GetNextLabel(const std::string&,int) const;
};










#if 0

class CMainParameters
{
	int m_Argc;
	char** m_Argv;
public:


	const char* operator[](int i) const {
		return At(i);		
	}
	const char* At(int i) const {
		if(i+1>=m_Argc) return 0;
		return m_Argv[i+1];
	}

	int Size(void) const {
		return m_Argc-1;
	}

	const char* GetModuleName(void) const {
		return m_Argv[0];
	}

	int GetLabelPos(const std::string&,int =0);
	int GetNextLabelPos(int);
	int GetNumberOfLabel(const std::string&);

	template<class T>
	bool GetValue(T& value,const std::string& label,int pos =0)
	{
		int i=GetLabelPos(label);
		if(i>=0) {
			std::stringstream str_stream;
			str_stream<<At(pos+1+i);
			str_stream>>value;
			return true;
		}
		value=T();
		return false;
	}
};


int CMainParameters::GetLabelPos(const std::string& label,int pos)
{
	for(int i=pos;i<Size();i++) {
		std::string str(At(i));
		if(str==label)
			return i;
	}
	return -1;
}

int CMainParameters::GetNextLabelPos(int pos)
{
	for(int i=pos;i<Size();i++) {
		std::string str(At(i));
		if(str[0]=='-')	return i;
	}
	return -1;
}

int CMainParameters::GetNumberOfLabel(const std::string& label)
{
	int number=0;
	int pos=0;
	while((pos=GetLabelPos(label,pos))!=-1) {
		number++;
		pos++;
	}
	return number;
}

#endif
