//hyp.math.test.cpp
//creation 22/03/01 Tycho

#include"hyp.dev.h"

void ShowMatrix(std::ostream& stream,hyp_fem::IMatrix* mat)
{
	for(int i=0;i<mat->GetNbRow();i++) {
		for(int j=0;j<mat->GetNbColumn();j++) {
			stream<<mat->GetValue(i,j)
				<<" ";
		}
		stream<<"\n";
	}
	stream<<"\n";
}

void TestMatrix(void)
{
	hyp_fem::t_spMathMatrix spMatrix[5];
	
	spMatrix[0].CreateInstance(hyp_fem::CLSID_hypCMathMatrix,0);
	spMatrix[1].CreateInstance(hyp_fem::CLSID_hypCMathVector,0);
	spMatrix[2].CreateInstance(hyp_fem::CLSID_hypCMathMatrix,0);
	spMatrix[3].CreateInstance(hyp_fem::CLSID_hypCMathVector,0);
	spMatrix[4].CreateInstance(hyp_fem::CLSID_hypCMathMatrix,0);

	spMatrix[0]->SetDim(5,5,0);
	for(int i=0;i<5;i++) {
		for(int j=0;j<5;j++) {
			spMatrix[0]->SetValue(i,j,i*j);
		}
	}
	
	ShowMatrix(hyp_ker::hyp_clog,spMatrix[0]);

	t_mask_array mask(5);
 	mask.resize(5);
	mask[0]=true;
	mask[1]=false;
	mask[2]=true;
	mask[3]=false;
	mask[4]=true;
	spMatrix[0]->EraseRowsAndColumns(mask,mask);
	ShowMatrix(hyp_ker::hyp_clog,spMatrix[0]);
	
#if 0
// Added by Pascal
// SetDim, SetValue, IncrValue
	spMatrix[1]->SetDim(5,1,54);
	spMatrix[1]->SetValue(0,0,-421);
	spMatrix[1]->IncrValue(1,0,-51);
	stream<<"Vecteur Matrix[1]: \n"<<spMatrix[1];
	stream<<"\nNb de colonnes: "<<spMatrix[1]->GetNbColumn();
	stream<<"\nNb de lignes: "<<spMatrix[1]->GetNbRow()<<"\n\n";

// Multiply (Matrix by a vector)
	spMatrix[2]->SetDim(5,5,13);
	stream<<"Matrice Matrix[2]: \n"<<spMatrix[2];
	spMatrix[2]->Multiply(spMatrix[1],spMatrix[3]);
	stream<<"Matrice Matrix[3]=Matrix[2] * Matrix[1]: \n"<<spMatrix[3];

// Add, Substract
	spMatrix[3]->Add(spMatrix[1]);
	stream<<"Vecteur Matrix[3] += Matrix[1]: \n"<<spMatrix[3];

	spMatrix[1]->Substract(spMatrix[3]);
	stream<<"Vecteur Matrix[1] -= Matrix[3]: \n"<<spMatrix[1];

// SetMatrix
	spMatrix[3]->SetMatrix(spMatrix[1]);
	stream<<"Vecteur Matrix[3] = Matrix[1]: \n"<<spMatrix[3];

	spMatrix[3]->SetMatrix(51);
	stream<<"Vecteur Matrix[3] = 51: \n"<<spMatrix[3];

// Extract
	spMatrix[3]->Extract(1,3,0,0,spMatrix[1]);
	stream<<"Vecteur Matrix[1] extrait de Matrix[3]: \n"<<spMatrix[1];

// Transpose
	spMatrix[1]->Transpose(spMatrix[2]);
	stream<<"Matrix3 transpos de Matrix[1]: \n"<<spMatrix[2];

// Multiply (by a scalar)
	spMatrix[1]->Multiply(2);
	stream<<"Vecteur Matrix[1] *= 2: \n"<<spMatrix[1];

// Exception launch
	spMatrix[1]->Invert();

	spMatrix[4]->SetDim(5,10,3);
	spMatrix[4]->Transpose(spMatrix[2]);
	stream<<"Matrix[4]: \n"<<spMatrix[4];
	stream<<"Matrix[2] transpose de Matrix[4]: \n"<<spMatrix[2];

	spMatrix[0]->SetDim(5,5,0);
	spMatrix[0]->SetValue(0,0,1);

	stream<<spMatrix;


// Pascal Test end
#endif

}
