/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 15/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/



#ifndef _hyp_com_factorieslibrary_h_
#define _hyp_com_factorieslibrary_h_

#ifndef hypfem_INSIDE_INTERN
#error Inclusion not allowed (include hyp.fem.intern.h instead)
#endif


/*!
\ingroup Ephy_FEM_Common
\HypDefaultDescripComponent s IFactoriesLibrary.
\HypCLSID CLSID_hypCFactoriesLibrary {5013D2E1-1967-11d5-A090-0080AD97951B}
\HypBeginInterf hyp.com.factorieslibrary.cpp
\HypEndInterf

\HypImplDetails
*/
class CFactoriesLibrary :
#ifdef hypfem_IDENTIFY_CONSTRUCTION_ON
protected CIDClass,
#endif
public IFactoriesLibrary,
public hyp_ker::CUnknown
{
public:
	/*! \HypCommonFonct*/
	CFactoriesLibrary(hyp_ker::IUnknown*);
	virtual ~CFactoriesLibrary();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID& ,void** );
	static hyp_ker::com_result CreateInstance(hyp_ker::IUnknown* ,hyp_ker::CUnknown** );
	/*!@}*/

	/*! \name IFactoriesLibrary Implementation
	@{
	*/
	virtual void CreateInstance(const hyp_ker::hypCLSID&,hyp_ker::IUnknown*,
		t_ulong,const hyp_ker::hypIID&,void**);
	virtual void CreateInstance(const char*,hyp_ker::IUnknown*,
		t_ulong,const hyp_ker::hypIID&,void**);
	/*!@}*/


private:
	struct SFactoryData
	{
		std::string m_ProgID;
		hyp_ker::hypCLSID m_CLSID;
		hyp_ker::IClassFactory* m_pFactory;

		SFactoryData(const std::string& prog_id,
			const hyp_ker::hypCLSID& CLSID,
			hyp_ker::IClassFactory* pFactory) :
		m_ProgID(prog_id),
		m_CLSID(CLSID),
		m_pFactory(pFactory) { }		
	};

	typedef std::vector<SFactoryData> t_Cont;
	typedef t_Cont::iterator t_ContIterator;
	//FIXTODO : why a static member?
	static t_Cont m_Cache;

	SFactoryData* GetData(const std::string&);
	SFactoryData* GetData(const hyp_ker::hypCLSID&);

};
#endif