/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 26/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_data_base_h_
#define _hyp_data_base_h_


#ifndef hypfem_INSIDE_INTERN
#error Inclusion not allowed (include hyp.fem.intern.h instead)
#endif

/*!
\ingroup Ephy_FEM_Data
\HypDefaultDescripComponent IGeometricBase.
\HypCLSID CLSID_hypCGeometricBase {2CC70D29-AB21-11d4-A098-0080AD97951B}
\HypBeginInterf hyp.data.base.cpp
\HypEndInterf

\HypImplDetails
*/
class CGeometricBase :
#ifdef hypfem_IDENTIFY_CONSTRUCTION_ON
protected CIDClass,
#endif
public IGeometricBase,
public hyp_ker::CUnknown
{
public:
	/*! \HypCommonFonct*/
	CGeometricBase(hyp_ker::IUnknown*);
	virtual ~CGeometricBase();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	static hyp_ker::com_result CreateInstance(hyp_ker::IUnknown* ,hyp_ker::CUnknown**);
	hyp_ker::com_result Init(void);	
	void FinalRelease(void);
	/*!@}*/

	/*! \name IGeometricSide Interface
	@{
	*/	
	virtual t_size GetNumberOfVertices();
	virtual IGeometricVertex* GetVertex(const t_label& );
	virtual IGeometricVertex* GetVertex(const t_real& ,const t_real& ,const t_real& );
	virtual t_label GetLabel(IGeometricVertex*);
	virtual void AddVertex(IGeometricVertex*,const t_label& );
	virtual void DeleteVertex(const t_label& );
	virtual IContainerKey* GetContainerOfVertices();
	virtual void SetFilter(const hyp_ker::hypIID* );
	virtual void ClearFilter();
	/*!@}*/

private:
	hyp_ker::IPtrUnknown m_spUnknownCont;	

	//filtre  l'ajout
	bool IsCompatibleWithFilter(IGeometricVertex*) const;
	typedef std::vector<const hyp_ker::hypIID*> t_ContainerForIID;
	t_ContainerForIID m_Filter;
};

#endif