/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#ifndef _hyp_data_object_h_
#define _hyp_data_object_h_

#ifndef hypfem_INSIDE_INTERN
#error Inclusion not allowed (include hyp.fem.intern.h instead)
#endif

/*!
\ingroup Ephy_FEM_Data
\HypDefaultDescripComponent IGeometricObject
\HypCLSID CLSID_hypCGeometricObject {487F6F41-18C6-11d5-A08F-0080AD97951B}
See \ref CreateInstanceForGeometry .
\arg \c CLSID_hypCGeometricObjectForFiniteElement {3CAAD661-2298-11d5-A098-0080AD97951B}
See \ref CreateInstanceForFiniteElement .
\HypBeginInterf hyp.data.object.cpp
\HypEndInterf

\HypImplDetails
*/
class CGeometricObject :
#ifdef hypfem_IDENTIFY_CONSTRUCTION_ON
protected CIDClass,
#endif
public IGeometricObject,/*
#ifdef hyp_WIN32
public ID3DRMMeshObject,
#endif
*/
public hyp_ker::CUnknown
//+ aggregation iserialize
{
public:
	/*! \HypCommonFonct*/
	CGeometricObject(hyp_ker::IUnknown*,const hyp_ker::hypCLSID* );
	virtual ~CGeometricObject();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	static hyp_ker::com_result CreateInstanceForGeometry(hyp_ker::IUnknown* ,hyp_ker::CUnknown** );
	static hyp_ker::com_result CreateInstanceForFiniteElement(hyp_ker::IUnknown* ,hyp_ker::CUnknown** );
	hyp_ker::com_result Init(void);	
	void FinalRelease(void);
	/*!@}*/


	/*! \name IGeometricObject Interface
	@{
	*/
	virtual IGeometricSide* CreateSide(const t_label&,const t_label_enum&);
	virtual IGeometricSide* CreateSide(const t_label&);
	virtual IGeometricVertex* CreateVertex(const t_label&,const t_real&,const t_real&,const t_real&);
	virtual IGeometricVertex* CreateVertex(const t_label&);		
	virtual void AddSide(IGeometricSide*,const t_label&);
	virtual void DeleteSide(const t_label&);
	virtual IContainerKey* GetContainerOfSides();
	virtual t_size GetNumberOfSides();
	virtual IGeometricSide* GetSide(const t_label&);
	/*!@}*/
/*
#ifdef hyp_WIN32
	//ID3DRMMeshObject
	virtual void InitializeD3DRMMesh(LPDIRECT3DRMMESHBUILDER2);
#endif
	*/

private:
	t_spContainerKey m_spSideContKey;	
	hyp_ker::IPtrUnknown m_spUnknownVertices;
	
	//quel composant est cre quand on appelle CreateVertex
	const hyp_ker::hypCLSID* m_pCLSID_Vertex;

};


#endif