/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 14/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

//FIXTODO : les points insers doivent tre visible

#include"hyp.fem.intern.h"

hyp_NAMESPACE_BEGIN_HYPFEM
hyp_NAMESPACE_BEGIN(data)


CGeometricSide::CGeometricSide(hyp_ker::IUnknown* pUnknownOuter) :
CUnknown(pUnknownOuter)
{
	hypfem_TRACE_CONSTRUCTION(("CGeometricSide"));
}

CGeometricSide::~CGeometricSide()
{
	hypfem_TRACE_DESTRUCTOR(("~CGeometricSide"));
}


hyp_ker::com_result CGeometricSide::NondelegatingQueryInterface(const hyp_ker::hypIID& iid,void** ppv)
{
	if(iid==IID_hypIGeometricSide) {
		return FinishQI(static_cast<IGeometricSide*>(this),ppv);
	} else if(iid==IID_hypIGeometricBase) {
		return FinishQI(static_cast<IGeometricBase*>(this),ppv);
	} else if(iid==IID_hypIContainer ||
		iid==IID_hypIContainerKey ||
		iid==IID_hypIContainerIterator) {
		return m_spUnknownBase->QueryInterface(iid,ppv);
	} else {
		return CUnknown::NondelegatingQueryInterface(iid,ppv);
	}
}
//DOXYTAG


hyp_ker::com_result CGeometricSide::CreateInstance(hyp_ker::IUnknown* pUnknownOuter,hyp_ker::CUnknown** ppNewComponent)
{
	*ppNewComponent=new CGeometricSide(pUnknownOuter);
	return hyp_ker::com_ok;
}


hyp_ker::com_result CGeometricSide::Init(void)
{
	hyp_ker::com_result hr=hyp_ker::com_ok;
	try {
		CGlobalFactory::CreateInstance(CLSID_hypCGeometricBase,GetOuterUnknown(),
			m_spUnknownBase.iid(),(void**)&m_spUnknownBase);
	} catch(hyp_ker::CComException hr) {
		hr=hyp_ker::com_false;
	}
	return hr;
}

void CGeometricSide::FinalRelease(void)
{
	CUnknown::FinalRelease();
}


void CGeometricSide::AddVertex(IGeometricVertex* pObject,const t_label& Label)
{
	pObject->Visible(true);
	GetGeometricBase()->AddVertex(pObject,Label);
}

hyp_NAMESPACE_END(data)
hyp_NAMESPACE_END_HYPFEM