/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 14/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#include"hyp.fem.intern.h"

hyp_NAMESPACE_BEGIN_HYPFEM
hyp_NAMESPACE_BEGIN(data)


CGeometricVertex::CGeometricVertex(hyp_ker::IUnknown* pUnknownOuter) :
CUnknown(pUnknownOuter),
m_Coord(3,0.0f)
{
	//note : qd le vertex est attach  une side, il est visible automatiquement
	m_bVisible=false;

	hypfem_TRACE_CONSTRUCTION(("CGeometricVertex"));
}

CGeometricVertex::~CGeometricVertex()
{
	hypfem_TRACE_DESTRUCTOR(("~CGeometricVertex"));
}


hyp_ker::com_result CGeometricVertex::NondelegatingQueryInterface(const hyp_ker::hypIID& iid,void** ppv)
{
	if(iid==IID_hypIGeometricVertex) {
		return FinishQI(static_cast<IGeometricVertex*>(this),ppv);
	} else {
		return CUnknown::NondelegatingQueryInterface(iid,ppv);
	}
}
//DOXYTAG


hyp_ker::com_result CGeometricVertex::CreateInstance(hyp_ker::IUnknown* pUnknownOuter,hyp_ker::CUnknown** ppNewComponent)
{
	*ppNewComponent=new CGeometricVertex(pUnknownOuter);
	return hyp_ker::com_ok;
}

t_real CGeometricVertex::GetCoord(const t_size& Label) const
{
	return m_Coord[Label];
}

void CGeometricVertex::SetCoord(const t_real& Scalar,const t_size& Label)
{
	m_Coord[Label]=Scalar;
}


hyp_NAMESPACE_END(data)
hyp_NAMESPACE_END_HYPFEM
