/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$

 Creation 14/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_data_vertex_h_
#define _hyp_data_vertex_h_

#ifndef hypfem_INSIDE_INTERN
#error Inclusion not allowed (include hyp.fem.intern.h instead)
#endif

/*!
\ingroup Ephy_FEM_Data
\HypDefaultDescripComponent IGeometricVertex.
\HypCLSID CLSID_hypCGeometricVertex {196913E8-18BD-11d5-A08F-0080AD97951B}
\HypBeginInterf hyp.data.vertex.cpp
\HypEndInterf

\HypImplDetails
*/
class CGeometricVertex :
#ifdef hypfem_IDENTIFY_CONSTRUCTION_ON
protected CIDClass,
#endif
public IGeometricVertex,
public hyp_ker::CUnknown
{
public:
	/*! \HypCommonFonct*/
	CGeometricVertex(hyp_ker::IUnknown*);
	virtual ~CGeometricVertex();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	static hyp_ker::com_result CreateInstance(hyp_ker::IUnknown* ,hyp_ker::CUnknown**);
	/*!@}*/

	/*! \name INode Implementation
	@{
	*/
	virtual t_real GetCoord(const t_size&) const;
	virtual void SetCoord(const t_real&,const t_size&);
	virtual bool IsVisible() const { return m_bVisible; }
	virtual void Visible(bool bVisible) { m_bVisible=bVisible; }
	/*@}*/

private:
	t_real_array m_Coord;
	bool m_bVisible;
};




#endif