/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 26/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_fem_element_h_
#define _hyp_fem_element_h_

#ifndef hypfem_INSIDE_INTERN
#error Inclusion not allowed (include hyp.fem.intern.h instead)
#endif

/*!
\ingroup Ephy_FEM_FEO
\HypDefaultDescripComponent IFEOElement.
\HypCLSID CLSID_hypCBrick42Element {2CC70D23-AB21-11d4-A098-0080AD97951B}.
See \ref CreateInstanceBrick42 .
\HypBeginInterf hyp.fem.element.cpp
\HypEndInterf

\HypImplDetails
*/
class CFEOElements :
#ifdef hypfem_IDENTIFY_CONSTRUCTION_ON
protected CIDClass,
#endif
public IFEOElement,
public hyp_ker::CUnknown
{
	typedef void (*PTR_INIT_MATRIX)(hyp_ker::IUnknown*,IMatrix*);
public:
	/*! \HypCommonFonct*/
	CFEOElements(hyp_ker::IUnknown*,PTR_INIT_MATRIX);
	virtual ~CFEOElements();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	hyp_ker::com_result Init(void);	
	void FinalRelease(void);

	//factories
	static hyp_ker::com_result CreateInstanceBrick42(hyp_ker::IUnknown* ,hyp_ker::CUnknown** );
	/*!@}*/

	/*! \name IFEOElement Interface
	@{
	*/	
	virtual const IFEOMaterial* GetMaterial() const;
	virtual void SetMaterial(IFEOMaterial*);
	virtual void SetKe(IMatrix*);
	/*!@}*/

private:
	static void InitMatrixForBrick42(hyp_ker::IUnknown*, IMatrix* );
	PTR_INIT_MATRIX m_InitMatrix;

	IFEOMaterial* m_pMaterial;	

	//aggregation
	hyp_ker::IPtrUnknown m_spUnknownContNodes;
	inline IGeometricBase* GetGeometricBase(void) {
		t_spGeometricBase spContNodes=m_spUnknownContNodes;
		return spContNodes;
	}
};

#endif	//!defined(_hyp_fem_element_h_)