/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 26/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


//rassemble les materiaux
//+factory  materiaux

#ifndef _hyp_fem_materials_h_
#define _hyp_fem_materials_h_

#ifndef hypfem_INSIDE_INTERN
#error Inclusion not allowed (include hyp.fem.intern.h instead)
#endif

/*!
\ingroup Ephy_FEM_FEO
\HypDefaultDescripComponent IFEOMaterial.
\HypCLSID CLSID_hypCDefaultMaterial {2CC70D21-AB21-11d4-A098-0080AD97951B}.
See \ref CreateInstanceDefault .
\arg \c CLSID_hypCSteelMaterial {2CC70D22-AB21-11d4-A098-0080AD97951B}.
See \ref CreateInstanceSteel .
\HypBeginInterf hyp.fem.materials.cpp
\HypEndInterf

\HypImplDetails
*/
class CFEOMaterials :
#ifdef hypfem_IDENTIFY_CONSTRUCTION_ON
protected CIDClass,
#endif
public IFEOMaterial,
public hyp_ker::CUnknown
{
public:	
	/*! \HypCommonFonct*/
	CFEOMaterials(hyp_ker::IUnknown*,t_real,t_real);
	virtual ~CFEOMaterials();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	hyp_ker::com_result Init(void);	
	void FinalRelease(void);

	//factories
	static hyp_ker::com_result CreateInstanceDefault(hyp_ker::IUnknown* ,hyp_ker::CUnknown** );
	static hyp_ker::com_result CreateInstanceSteel(hyp_ker::IUnknown* ,hyp_ker::CUnknown** );
	/*!@}*/

	/*! \name IFEOMaterial Interface
	@{
	*/
	virtual void SetYoung(const t_real&);
	virtual t_real GetYoung() const;
	virtual void SetPoisson(const t_real&);
	virtual t_real GetPoisson() const;
	/*!@}*/

private:
	t_real m_Young;
	t_real m_Poisson;

};

#endif