/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 26/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#ifndef _hyp_fem_node_h_
#define _hyp_fem_node_h_


#ifndef hypfem_INSIDE_INTERN
#error Inclusion not allowed (include hyp.fem.intern.h instead)
#endif

/*!
\ingroup Ephy_FEM_FEO
\HypDefaultDescripComponent IFEOBoundaryConditions.
\HypCLSID CLSID_hypCFEONode {2CC70D25-AB21-11d4-A098-0080AD97951B}
\HypBeginInterf hyp.fem.node.cpp
\HypEndInterf

\HypImplDetails
*/
class CFEONode :
#ifdef hypfem_IDENTIFY_CONSTRUCTION_ON
protected CIDClass,
#endif
public IFEOBoundaryConditions,
public hyp_ker::CUnknown
{
public:
	/*! \HypCommonFonct*/
	CFEONode(hyp_ker::IUnknown*);
	virtual ~CFEONode();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	static hyp_ker::com_result CreateInstance(hyp_ker::IUnknown* ,hyp_ker::CUnknown** );
	hyp_ker::com_result Init(void);	
	void FinalRelease(void);
	/*!@}*/

	/*! \name IBoundaryConditions Interface
	@{
	*/
	virtual void FixDOF(const t_size&);
	virtual void UnFixDOF(const t_size&);
	virtual void ClearDOF();
	virtual bool IsFixed(const t_size&) const;
	/*!@}*/

private:
	t_mask_array m_DOFFixed;
	hyp_ker::IPtrUnknown m_spUnknownVertex;

};
#endif
