/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 26/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#ifndef _hyp_fem_server_h_
#define _hyp_fem_server_h_

/*! \file
Contents the declaration of the guids contained in the server
*/


//------------------------------------------------------------------------
//common components
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// {1187D861-9F81-11d4-A08F-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCContainer, 
0x1187d861, 0x9f81, 0x11d4, 0xa0, 0x8f, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {5013D2E1-1967-11d5-A090-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCFactoriesLibrary, 
0x5013d2e1, 0x1967, 0x11d5, 0xa0, 0x90, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);
//------------------------------------------------------------------------


//------------------------------------------------------------------------
//math components
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// {BF8B3F61-1F01-11d5-A095-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCMathMatrix, 
0xbf8b3f61, 0x1f01, 0x11d5, 0xa0, 0x95, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {BF8B3F62-1F01-11d5-A095-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCMathVector, 
0xbf8b3f62, 0x1f01, 0x11d5, 0xa0, 0x95, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);
//------------------------------------------------------------------------


//------------------------------------------------------------------------
//data components
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// {196913E8-18BD-11d5-A08F-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCGeometricVertex, 
0x196913e8, 0x18bd, 0x11d5, 0xa0, 0x8f, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {2CC70D29-AB21-11d4-A098-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCGeometricBase, 
0x2cc70d29, 0xab21, 0x11d4, 0xa0, 0x98, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {68038B80-1DD5-11d5-A094-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCGeometricSide, 
0x68038b80, 0x1dd5, 0x11d5, 0xa0, 0x94, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {487F6F41-18C6-11d5-A08F-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCGeometricObject,
0x487f6f41, 0x18c6, 0x11d5, 0xa0, 0x8f, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {3CAAD661-2298-11d5-A098-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCGeometricObjectForFiniteElement, 
0x3caad661, 0x2298, 0x11d5, 0xa0, 0x98, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);
//------------------------------------------------------------------------


//------------------------------------------------------------------------
//FEO components
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// {2CC70D21-AB21-11d4-A098-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCDefaultMaterial, 
0x2cc70d21, 0xab21, 0x11d4, 0xa0, 0x98, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {2CC70D22-AB21-11d4-A098-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCSteelMaterial, 
0x2cc70d22, 0xab21, 0x11d4, 0xa0, 0x98, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {2CC70D23-AB21-11d4-A098-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCBrick42Element, 
0x2cc70d23, 0xab21, 0x11d4, 0xa0, 0x98, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {2CC70D25-AB21-11d4-A098-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCFEONode, 
0x2cc70d25, 0xab21, 0x11d4, 0xa0, 0x98, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

// {2CC70D26-AB21-11d4-A098-0080AD97951B}
hyp_DEFINE_GUID(CLSID_hypCFEOMesh, 
0x2cc70d26, 0xab21, 0x11d4, 0xa0, 0x98, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

//------------------------------------------------------------------------



#endif