/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 24/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_file_base_h_
#define _hyp_file_base_h_

class CImplBase :
public IFileObject
{
protected:
	//Implementation d'une partie de IObjectFile
	virtual void SetObject(hyp_ker::IUnknown*);
	
	std::string GetHead(void);

	hyp_ker::IPtrUnknown m_spUnknownMesh;

	inline hyp_fem::IGeometricBase* GetGeometricBase(void) {
		hyp_fem::t_spGeometricBase spBaseMesh=m_spUnknownMesh;
		return spBaseMesh;
	}
	inline hyp_fem::IGeometricObject* GetGeometricObject(void) {
		hyp_fem::t_spGeometricObject spObjectMesh=m_spUnknownMesh;
		return spObjectMesh;
	}
	inline hyp_fem::IFEOMesh* GetFEOMesh(void) {
		hyp_fem::t_spFEOMesh spMeshMesh=m_spUnknownMesh;
		return spMeshMesh;
	}
};




#endif	//!defined(_hyp_file_base_h_)