/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 02/05/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#include"hyp.out.intern.h"

hyp_NAMESPACE_BEGIN_HYPOUT
hyp_NAMESPACE_BEGIN(dxfile)

const CFlag Flag_VERTEX_VISIBLE(0);

const CFlag Flag_VERTEX_FIXED_IN_X(0);
const CFlag Flag_VERTEX_FIXED_IN_Y(1);
const CFlag Flag_VERTEX_FIXED_IN_Z(2);

DWORD CXImplFile::CXOF::GetVertexProperties(const CMeshData::SVertex& vertex)
{
	CFlag prop;
	if(vertex.b_visible) {
		prop.SetFlag(Flag_VERTEX_VISIBLE);
	}
	//MODIF
	return prop.GetFlag();
}

DWORD CXImplFile::CXOF::GetVertexDOF(const CMeshData::SVertex& vertex)
{
	CFlag dof;
	if(vertex.dof[0]) dof.SetFlag(Flag_VERTEX_FIXED_IN_X);
	if(vertex.dof[1]) dof.SetFlag(Flag_VERTEX_FIXED_IN_Y);
	if(vertex.dof[2]) dof.SetFlag(Flag_VERTEX_FIXED_IN_Z);

	return dof.GetFlag();
}

void CXImplFile::CXOF::SetVertexDOF(const CFlag& flag,hyp_fem::IFEOBoundaryConditions* p_node)
{
	if(flag.HaveFlag(Flag_VERTEX_FIXED_IN_X.GetFlag()))
		p_node->FixDOF(0);
	if(flag.HaveFlag(Flag_VERTEX_FIXED_IN_Y.GetFlag()))
		p_node->FixDOF(1);
	if(flag.HaveFlag(Flag_VERTEX_FIXED_IN_Z.GetFlag()))
		p_node->FixDOF(2);
}

void CXImplFile::CXOF::SetVertexProperties(const CFlag& flag,hyp_fem::IGeometricVertex* p_vertex)
{
	if(flag.HaveFlag(Flag_VERTEX_VISIBLE.GetFlag()))
		p_vertex->Visible(true);
	else
		p_vertex->Visible(false);
}


hyp_NAMESPACE_END(dxfile)
hyp_NAMESPACE_END_HYPOUT