/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 02/05/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#include"hyp.out.intern.h"


hyp_NAMESPACE_BEGIN_HYPOUT
hyp_NAMESPACE_BEGIN(stdfile)


const int CBox::ms_ColumnSize_Bool=8;
const int CBox::ms_ColumnSize_Label=5;
const int CBox::ms_ColumnSize_Real=10;
const int CBox::ms_ColumnSize_List=20;

const int CTable::ms_JumpAfterXLines=20;
const int CTable::ms_PosTable=20;
const int CColumn::ms_PosColumn=10;

void CBox::write(std::ostream& stream) const
{
	int new_size=(Size()-static_cast<int>(Value().size()))/2;
	if(new_size>0) stream<<std::setw(new_size)<<"";
	stream<<Value();
	if(new_size>0) {
		new_size=Size()-Value().size()-new_size;
		stream<<std::setw(new_size)<<"";
	}
}


void CColumn::write(std::ostream& stream) const
{
	for(int i=0;i<m_BoxEnum.size();i++) {
		stream<<std::setw(Size())<<"";
		m_BoxEnum[i].write(stream);
	}
	stream<<"\n";
}


void CColumnHead::write(std::ostream& stream) const
{
	stream<<"\n";
	std::ios_base::fmtflags f=stream.flags();
	stream<<std::uppercase;
	CColumn::write(stream);
	stream.setf(f);
	stream<<"\n";
}

void CTable::write(std::ostream& stream) const
{
	stream<<"\n"<<std::setw(Size())<<"->"<<Value()<<"\n";
	for(int i=0;i<m_ColumnEnum.size();i++) {
		if(i%ms_JumpAfterXLines==0)	{
			m_ColumnHead.write(stream);
		}
		m_ColumnEnum[i].write(stream);
	}
	stream<<"\n";
}


hyp_NAMESPACE_END(stdfile)
hyp_NAMESPACE_END_HYPOUT
