/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 19/04/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_file_implstd_h_
#define _hyp_file_implstd_h_

/*!
\ingroup OUT
\HypDefaultDescripComponent IShowMeshObject.
\HypCLSID CLSID_hypCObjectStdFile {321538C1-3513-11d5-A099-0080AD97951B}
\HypBeginInterf hyp.file.implstd.cpp
\HypEndInterf

\HypImplDetails
*/
class CStdImplFile :
public CImplBase,
public IShowMeshObject,
hyp_ker::CUnknown
{
public:
	/*! \HypCommonFonct*/
	CStdImplFile(hyp_ker::IUnknown*);
	virtual ~CStdImplFile();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	static hyp_ker::com_result CreateInstance(hyp_ker::IUnknown* ,hyp_ker::CUnknown**);
	hyp_ker::com_result Init(void);	
	void FinalRelease(void);
	/*!@}*/

	/*! \name IFileObject
	@{
	*/
	virtual void SetObject(hyp_ker::IUnknown* pObject) {
		CImplBase::SetObject(pObject);
	}
	/*!@}*/

	/*! \name IShowMeshObject Interface
	@{
	*/	
	virtual void SetOutput(const std::string&);
	virtual void SetOutput(const std::ostream&);
	virtual void CloseOutput();	
	virtual void ShowNodes();
	virtual void ShowSides();
	virtual void ShowElements();
	virtual void ShowMatrix();
	virtual void ShowMatrixDim();
	virtual void ShowForceMask();
	virtual void ShowRenderMask();
	virtual void ShowDisplacements();
	virtual void ShowGlobalDisplacements();
	virtual void ShowForces();
	virtual void ShowGlobalForces();
	virtual void ShowAll();
	/*!@}*/

private:	
	void TEST_OUTPUT(void) {
		if(!m_pStream) hyp_THROW_COM2(hyp_ker::com_false, ("Output not initialized") );
	}
	void OpenFile(const std::string&);
	void CloseFile(void);

	void ShowMask(const t_mask_array&,const std::string&);
	void ShowArray(const t_real_array&,const std::string&);
	std::ostream* m_pStream;


};


#endif	//!defined(_hyp_file_implstd_h_)