/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 24/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#include"hyp.out.intern.h"
//pour les templates standards
//inclusion une seule fois
#include<rmxftmpl.h>

hyp_NAMESPACE_BEGIN_HYPOUT
hyp_NAMESPACE_BEGIN(dxfile)


CXImplFile::CXImplFile(hyp_ker::IUnknown* pUnknownOuter) :
CUnknown(pUnknownOuter)
{
	HRESULT hr=DirectXFileCreate(&m_spDXFile);
	if(FAILED(hr)) hyp_THROW_DXFILE(hr);
	
	//Register classic templates
	hyp_CHECK_HR( m_spDXFile->RegisterTemplates((LPVOID)D3DRM_XTEMPLATES,
                                        D3DRM_XTEMPLATE_BYTES) );
    
	//Register hyperion templates
	hyp_CHECK_HR( m_spDXFile->RegisterTemplates((LPVOID)g_XTemplates,
                                        strlen(g_XTemplates)) );

}


CXImplFile::~CXImplFile()
{
	hyp_TRACE(("~CXImplFile"));
}


hyp_ker::com_result CXImplFile::NondelegatingQueryInterface(const hyp_ker::hypIID& iid,void** ppv)
{
	if(iid==IID_hypID3DMeshObject) {
		return FinishQI(static_cast<ID3DMeshObject*>(this),ppv);
	} else {
		return CUnknown::NondelegatingQueryInterface(iid,ppv);
	}
}
//DOXYTAG

hyp_ker::com_result CXImplFile::CreateInstance(hyp_ker::IUnknown* pUnknownOuter,hyp_ker::CUnknown** ppNewComponent)
{
	*ppNewComponent=new CXImplFile(pUnknownOuter);
	return hyp_ker::com_ok;
}


hyp_ker::com_result CXImplFile::Init(void)
{
	return hyp_ker::com_ok;
}

void CXImplFile::FinalRelease(void)
{
	CUnknown::FinalRelease();
}

//ID3DMeshObject
void CXImplFile::InitializeD3DMeshBuilder(LPDIRECT3DRMMESHBUILDER3 pComObject)
{
#if 1
	CMeshData data(m_spUnknownMesh);
	CMeshData::SVerticesEnum vertices=data.GetVerticesEnum();
	CMeshData::SSidesEnum sides=data.GetSidesEnum();

	//FIXTODO : enlever les noeuds non visible, mais "difficile" car offset dans les sides
	
	int nVertices=vertices.size();	
	//tableau de vertices
	D3DVECTOR* p_vertices=new D3DVECTOR[nVertices];
	for(int i=0;i<vertices.size();i++) {
		p_vertices[i].x=vertices[i].coord[0];
		p_vertices[i].y=vertices[i].coord[1];
		p_vertices[i].z=vertices[i].coord[2];
	}

	//tableau de sides
	int nFaceData=sides.GetTotalRefNodes();
	nFaceData+=sides.size()+1;	//0  la fin
	DWORD* face_data=new DWORD[nFaceData];
	memset(face_data,0,sizeof(DWORD)*nFaceData);
	int offset=0;
	for(i=0;i<sides.size();i++) {
		face_data[offset]=static_cast<DWORD>(sides[i].vertices_global.size());
		offset++;
		for(int j=0;j<sides[i].vertices_global.size();j++) {
			face_data[offset]=static_cast<DWORD>(sides[i].vertices_global[j]);
			offset++;
		}		
	}
	face_data[offset]=0;


	hyp_CHECK_HR( pComObject->AddFaces(nVertices,p_vertices,0,NULL,face_data,NULL) );
	delete[] p_vertices;
	delete[] face_data;

#else

	// This cube has twelve triangular faces, defined by 8 vertices
D3DVECTOR vertices[]  = {
	
   -0.440000, -0.000000, -0.440000,
    0.440000, -0.000000, -0.440000,
   -0.440000, -0.000000,  0.440000,
    0.440000, -0.000000,  0.440000,
   -0.440000,  0.880000, -0.440000,
    0.440000,  0.880000, -0.440000,
   -0.440000,  0.880000,  0.440000,
    0.440000,  0.880000,  0.440000 };

// Each of the cube's six faces has four vertex normals, for a
// total of 24
D3DVECTOR normals[]   = {
   -0.000000, -1.000000, -0.000000,
    0.000000,  0.000000, -1.000000,
   -1.000000,  0.000000,  0.000000,
   -0.000000, -1.000000, -0.000000,
    0.000000,  0.000000, -1.000000,
    1.000000,  0.000000,  0.000000,
   -0.000000, -1.000000, -0.000000,
    0.000000,  0.000000,  1.000000,
   -1.000000,  0.000000,  0.000000,
   -0.000000, -1.000000, -0.000000,
    1.000000,  0.000000,  0.000000,
    0.000000,  0.000000,  1.000000,
    0.000000,  1.000000, -0.000000,
    0.000000,  0.000000, -1.000000,
   -1.000000,  0.000000,  0.000000,
    0.000000,  1.000000, -0.000000,
    0.000000,  0.000000, -1.000000,
    1.000000,  0.000000,  0.000000,
    0.000000,  1.000000, -0.000000,
    0.000000,  0.000000,  1.000000,
   -1.000000,  0.000000,  0.000000,
    0.000000,  1.000000, -0.000000,
    1.000000,  0.000000,  0.000000,
    0.000000,  0.000000,  1.000000 }; // Last normal
DWORD faceData[] = { 3,  0, 0,  3,  9,  2,  6, 
                     3,  3, 9,  0,  0,  1,  3, 
                     3,  4, 12,  7, 21,  5, 15,
                     3,  7, 21,  4, 12,  6, 18,
                     3,  0,  1,  5, 16,  1,  4,
                     3,  5, 16,  0,  1,  4, 13,
                     3,  1,  5,  7, 22,  3, 10,
                     3,  7, 22,  1,  5,  5, 17,
                     3,  3, 11,  6, 19,  2,  7,
                     3,  6, 19,  3, 11,  7, 23,
                     3,  2,  8,  4, 14,  0,  2,
                     3,  4, 14,  2,  8,  6, 20, 0 };
p_mesh_builder->AddFaces( 8,           // Number of vertices
                 vertices,           // Array of vertices
                       24,           // Number of vertex normals 
                  normals,           // Array of vertex normals
                 faceData,           // Array of face data
                     NULL );
#endif

}

void CXImplFile::SaveD3DHypMesh(const std::string& FileName)
{
	CXOFSave save(this,FileName);
	save.SaveMesh();
	save.SaveMatrix();
}

void CXImplFile::SaveD3DMeshBuilder(const std::string& FileName)
{
	CXOFSave save(this,FileName);
	save.SaveGeometry();
}

void CXImplFile::LoadD3DHypMesh(const std::string& FileName)
{
	CXOFLoad load(this,FileName);
	load.Load();
}



//Save
CXImplFile::CXOFSave::CXOFSave(CXImplFile* impl_file,const std::string& path) :
CXOF(impl_file)
{
	hyp_CHECK_HR( GetXOFile()->CreateSaveObject(path.c_str(),    // filename
                                       DXFILEFORMAT_TEXT,     // binary or text
                                       &m_pXOFSave) );

	//ecrit dans le fichier les templates
	const GUID* pguid[6];
	pguid[0]=&TID_HYPMatrix;
	pguid[1]=&TID_HYPNode;
	pguid[2]=&TID_HYPBase;
	pguid[3]=&TID_HYPElement;
	pguid[4]=&TID_HYPSide;
	pguid[5]=&TID_HYPMesh;
	hyp_CHECK_HR( m_pXOFSave->SaveTemplates(6,pguid) );
}

CXImplFile::CXOFSave::~CXOFSave(void)
{
	m_pXOFSave->Release();
}

void CXImplFile::CXOFSave::CreateDataObject(REFGUID rguidTemplate,
								  LPCSTR szName,const GUID* pguid,
								  DWORD cbSize,LPVOID pvData)
{
	hyp_ker::CSmartInterface<IDirectXFileData> sp_XOFData;
	hyp_CHECK_HR(m_pXOFSave->CreateDataObject(rguidTemplate,
                                        szName,pguid,
										cbSize,pvData,
                                        &sp_XOFData));

	hyp_CHECK_HR( m_pXOFSave->SaveData(sp_XOFData) );
}

void CXImplFile::CXOFSave::SaveMesh(void)
{
	int i=0;
	int j=0;
	DWORD size_memory=0;
	DWORD dw_value=0;
	FLOAT f_value=0;

	CMeshData data(GetMeshUnknown());
	CMeshData::SVerticesEnum vertices=data.GetVerticesEnum();
	CMeshData::SSidesEnum sides=data.GetSidesEnum();
	CMeshData::SElementsEnum elements=data.GetElementsEnum();

	size_memory=sizeof(DWORD)+	//nbre de nodes
		(sizeof(DWORD)+3*sizeof(FLOAT)+2*sizeof(DWORD))*vertices.size() +
		sizeof(DWORD)+	//nbre d'elements
		2 * elements.size() * sizeof(DWORD) + 2 * elements.GetTotalRefNodes() * sizeof(DWORD) +
		sizeof(DWORD) +	//nbre de sides
		2 * sides.size() * sizeof(DWORD) + 2 * sides.GetTotalRefNodes() * sizeof(DWORD);
	
	CChunkMemory chunk(size_memory);
	
	//nodes
	dw_value=vertices.size();
	chunk.InsertData(&dw_value);

	for(i=0;i<vertices.size();i++) {
		dw_value=vertices[i].label;
		chunk.InsertData(&dw_value);

		for(int j=0;j<3;j++) {
			f_value=vertices[i].coord[j];
			chunk.InsertData(&f_value);
		}
		dw_value=GetVertexProperties(vertices[i]);
		chunk.InsertData(&dw_value);
		
		dw_value=GetVertexDOF(vertices[i]);
		chunk.InsertData(&dw_value);
	}

	chunk.InsertBases(elements);
	chunk.InsertBases(sides);

	CreateDataObject(TID_HYPMesh,"Mesh",NULL,chunk.Size(),chunk.Chunk());
}

void CXImplFile::CXOFSave::SaveMatrix(void)
{
	hyp_fem::t_spFEOMesh spMesh=GetMeshUnknown();
	DWORD nRows=spMesh->K()->GetNbRow();
	DWORD nColumns=spMesh->K()->GetNbColumn();
	
	DWORD size_memory=2 * sizeof(DWORD) + nRows * nColumns * sizeof(FLOAT);
	
	CChunkMemory chunk(size_memory);
	chunk.InsertData(&nRows);
	chunk.InsertData(&nColumns);

	for(int i=0;i<nRows;i++) {
		for(int j=0;j<nColumns;j++) {
			FLOAT value=spMesh->K()->GetValue(i,j);
			chunk.InsertData(&value);
		}
	}
	
	CreateDataObject(TID_HYPMatrix,"K",NULL,chunk.Size(),chunk.Chunk());	
}

void CXImplFile::CXOFSave::SaveGeometry(void)
{
	int i=0;
	DWORD size_memory=0;
	DWORD dw_data;

	CMeshData data(GetMeshUnknown());
	CMeshData::SVerticesEnum vertices=data.GetVerticesEnum();
	CMeshData::SSidesEnum sides=data.GetSidesEnum();

	size_memory=sizeof(DWORD) +	//nbre de vertices
		3 * sizeof(FLOAT) * vertices.size() +	//nbre de coord
		sizeof(DWORD) +	//nbre de sides
		sizeof(DWORD) * sides.size() +	//nbr de labels par side
		sizeof(DWORD) * sides.GetTotalRefNodes();	//labels pour decrire tous les sides
		
	CChunkMemory chunk(size_memory);
	
	dw_data=vertices.size();
	chunk.InsertData(&dw_data);

	for(i=0;i<vertices.size();i++) {
		for(int j=0;j<3;j++) {
			FLOAT coord=vertices[i].coord[j];
			chunk.InsertData(&coord);
		}
	}

	dw_data=sides.size();
	chunk.InsertData(&dw_data);
	
	for(i=0;i<sides.size();i++) {
		dw_data=sides[i].vertices_global.size();
		chunk.InsertData(&dw_data);
		for(int j=0;j<3/*sides[i].vertices_global.size()*/;j++) {
			dw_data=sides[i].vertices_global[j];
			chunk.InsertData(&dw_data);
		}
	}

	CreateDataObject(TID_D3DRMMesh,"cube1",NULL,chunk.Size(),chunk.Chunk());
}


//load
CXImplFile::CXOFLoad::CXOFLoad(CXImplFile* impl_file,const std::string& path) :
CXOF(impl_file)
{
	hyp_CHECK_HR( GetXOFile()->CreateEnumObject((LPVOID)(path.c_str()),
		DXFILELOAD_FROMFILE,
		&m_pXOFEnum) );
}

CXImplFile::CXOFLoad::~CXOFLoad()
{
	m_pXOFEnum->Release();
}

void CXImplFile::CXOFLoad::Load(void)
{
	hyp_fem::t_spFEOMesh spMesh=GetMeshUnknown();
	spMesh->ClearAllData();

	// Enumerate top level objects
	// Top level objects are always data object.
	LPDIRECTXFILEDATA p_XOFObj;
	while( SUCCEEDED(m_pXOFEnum->GetNextDataObject(&p_XOFObj)) ) {
		const GUID *type;
		// Get the type of the object
		hyp_CHECK_HR( p_XOFObj->GetType(&type) );
		
		if (*type == TID_HYPMesh) {
			LoadMesh(p_XOFObj);
		} else if(*type==TID_HYPMatrix) {
			LoadMatrix(p_XOFObj);
		}
	}
}

void CXImplFile::CXOFLoad::LoadMesh(LPDIRECTXFILEDATA p_data)
{
	//on supprime toutes les nodes, les sides et les lments
	hyp_fem::t_spFEOMesh spMesh=GetMeshUnknown();
	hyp_fem::t_spGeometricObject spObject=GetMeshUnknown();
	hyp_fem::t_spGeometricBase spBase=GetMeshUnknown();

	CChunkMemoryRead chunk(p_data);

	DWORD dw_data=0;
	DWORD dw_label=0;
	FLOAT f_data=0;
	int i=0;

	//on charge les nodes
	DWORD nNodes=0;
	chunk.Extract(&nNodes);
	for(i=0;i<nNodes;i++) {
		hyp_fem::t_spGeometricVertex spVertex;
		chunk.Extract(&dw_label);
		spVertex=spObject->CreateVertex(dw_label);
		for(int j=0;j<3;j++) {
			chunk.Extract(&f_data);
			spVertex->SetCoord(f_data,j);
		}
		chunk.Extract(&dw_data);
		CFlag flag_p;
		flag_p.SetFlag(dw_data);
		SetVertexProperties(flag_p,spVertex);

		chunk.Extract(&dw_data);
		CFlag flag_dof;
		flag_dof.SetFlag(dw_data);
		hyp_fem::t_spFEOBoundaryConditions spBoundary;
		spBoundary=spVertex;
		SetVertexDOF(flag_dof,spBoundary);
	}

	//on charge les lments
	DWORD nElements=0;
	chunk.Extract(&nElements);
	for(i=0;i<nElements;i++) {
		chunk.Extract(&dw_label);
		DWORD nRefNodes=0;
		chunk.Extract(&nRefNodes);
		t_label_enum e(nRefNodes);
		for(int j=0;j<nRefNodes;j++) {
			chunk.Extract(&dw_data);
			e[j]=static_cast<t_label>(dw_data);
		}
		for(j=0;j<nRefNodes;j++) {
			//FIXTODO : pas besoin de ces donnes -> supposition 0,1,2,..,nRefNodes
			chunk.Extract(&dw_data);
		}
		spMesh->CreateElement(static_cast<t_label>(dw_label),e);
	}

	//FIXTODO : copie de code :-(
	//on charge les sides
	//DWORD nElements=0;
	chunk.Extract(&nElements);
	for(i=0;i<nElements;i++) {
		chunk.Extract(&dw_label);
		DWORD nRefNodes=0;
		chunk.Extract(&nRefNodes);
		t_label_enum e(nRefNodes);
		for(int j=0;j<nRefNodes;j++) {
			chunk.Extract(&dw_data);
			e[j]=static_cast<t_label>(dw_data);
		}
		for(j=0;j<nRefNodes;j++) {
			//FIXTODO : pas besoin de ces donnes -> supposition 0,1,2,..,nRefNodes
			chunk.Extract(&dw_data);
		}
		spObject->CreateSide(static_cast<t_label>(dw_label),e);
	}

}

void CXImplFile::CXOFLoad::LoadMatrix(LPDIRECTXFILEDATA p_data)
{
	//on obtient la matrice de mesh
	hyp_fem::IMatrix* p_matrix=0;
	hyp_fem::t_spFEOMesh spMesh=GetMeshUnknown();
	p_matrix=spMesh->K();
	
	CChunkMemoryRead chunk(p_data);
	DWORD nRows=0;
	DWORD nColumns=0;
	chunk.Extract(&nRows);
	chunk.Extract(&nColumns);

	p_matrix->SetDim(nRows,nColumns,0);

	FLOAT f_data=0;
	for(int i=0;i<nRows;i++) {
		for(int j=0;j<nColumns;j++) {
			chunk.Extract(&f_data);
			p_matrix->SetValue(i,j,f_data);
		}
	}
}



hyp_NAMESPACE_END(dxfile)
hyp_NAMESPACE_END_HYPOUT