/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 24/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

//implementeur d'un modle pont "degnr", car un seul format


#ifndef _hyp_file_implx_h_
#define _hyp_file_implx_h_


/*!
\ingroup OUT
\HypDefaultDescripComponent ID3DMeshObject.
\HypCLSID CLSID_hypCObjectXFile {C0FD1A61-206B-11d5-A096-0080AD97951B}
\HypBeginInterf hyp.file.implx.cpp
\HypEndInterf

\HypImplDetails
*/
class CXImplFile :
public CImplBase,
public ID3DMeshObject,
hyp_ker::CUnknown
{
public:
	/*! \HypCommonFonct*/
	CXImplFile(hyp_ker::IUnknown*);
	virtual ~CXImplFile();
	hyp_DECLARE_IUNKNOWN
	virtual hyp_ker::com_result NondelegatingQueryInterface(const hyp_ker::hypIID&,void**);
	static hyp_ker::com_result CreateInstance(hyp_ker::IUnknown* ,hyp_ker::CUnknown**);
	hyp_ker::com_result Init(void);	
	void FinalRelease(void);
	/*!@}*/

	/*! \name IFileObject
	@{
	*/
	virtual void SetObject(hyp_ker::IUnknown* pObject) {
		CImplBase::SetObject(pObject);
	}
	/*!@}*/

	/*! \name IShowMeshObject Interface
	@{
	*/	
	virtual void InitializeD3DMeshBuilder(LPDIRECT3DRMMESHBUILDER3);
	virtual void SaveD3DMeshBuilder(const std::string&);
	virtual void SaveD3DHypMesh(const std::string&);
	virtual void LoadD3DHypMesh(const std::string&);
	/*!@}*/

	class CXOF {
		CXImplFile* m_pImplFile;
	protected:
		CXOF(CXImplFile* impl_file) : m_pImplFile(impl_file) { }
		inline hyp_ker::IUnknown* GetMeshUnknown(void) {
			return m_pImplFile->m_spUnknownMesh;
		}
		inline LPDIRECTXFILE GetXOFile(void) {
			return m_pImplFile->m_spDXFile;
		}
		
		DWORD GetVertexProperties(const CMeshData::SVertex&);
		DWORD GetVertexDOF(const CMeshData::SVertex&);
		void SetVertexDOF(const CFlag&,hyp_fem::IFEOBoundaryConditions*);
		void SetVertexProperties(const CFlag&,hyp_fem::IGeometricVertex*);		
	};

	class CXOFSave :
	protected CXOF {
	public:
		CXOFSave(CXImplFile*, const std::string&);
		~CXOFSave();

		void SaveMesh(void);
		void SaveMatrix(void);
		void SaveGeometry(void);

	private:
		void CreateDataObject(REFGUID, LPCSTR,const GUID*,DWORD,LPVOID);			
		LPDIRECTXFILESAVEOBJECT m_pXOFSave;
	};
	
	class CXOFLoad :
	protected CXOF {
	public:
		CXOFLoad(CXImplFile*,const std::string&);
		~CXOFLoad();
		void Load(void);
		void LoadMesh(LPDIRECTXFILEDATA);
		void LoadMatrix(LPDIRECTXFILEDATA);

	private:		
		LPDIRECTXFILEENUMOBJECT m_pXOFEnum;
	};

	
	
private:
	hyp_ker::CSmartInterface<IDirectXFile> m_spDXFile;

	friend CXOF;
};


#endif