/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 24/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#include"hyp.out.intern.h"



hyp_NAMESPACE_BEGIN_HYPOUT
hyp_NAMESPACE_BEGIN(dxfile)

char* g_XTemplates = "xof 0303txt 0032				\
template HypMatrix {								\
 <AF8B31E1-36A0-11d5-A099-0080AD97951B>				\
 DWORD nRows;										\
 DWORD nColumns;									\
 array FLOAT Matrix[nRows][nColumns];				\
}													\
template HypNode {									\
 <5151B1C2-3F11-11d5-A099-0080AD97951B>				\
 DWORD Label;										\
 FLOAT X;											\
 FLOAT Y;											\
 FLOAT Z;											\
 DWORD Properties;									\
 DWORD DOF;											\
}													\
template HypBase {									\
 <5151B1C5-3F11-11d5-A099-0080AD97951B>				\
 DWORD Label;										\
 DWORD nRefNodes;									\
 array DWORD RefGlobalNodes[nRefNodes];				\
 array DWORD RefLocalNodes[nRefNodes];				\
}													\
template HypElement {								\
 <5151B1C6-3F11-11d5-A099-0080AD97951B>				\
 HypBase Base;										\
}													\
template HypSide {									\
 <5151B1C7-3F11-11d5-A099-0080AD97951B>				\
 HypBase Base;										\
}													\
template HypMesh {									\
 <5151B1C1-3F11-11d5-A099-0080AD97951B>				\
  DWORD nNodes;										\
  array HypNode nodes[nNodes];						\
  DWORD nSides;										\
  array HypSide sides[nSides];						\
  DWORD nElements;									\
  array HypElement elements[nElements];				\
}";

std::string GetErrorInfoForXFile(HRESULT hr)
{
	switch(hr) {
	case DXFILE_OK:
return "Command completed successfully. Equivalent to DD_OK.";
	case DXFILEERR_BADALLOC :
return "Memory allocation failed."; 
	case DXFILEERR_BADARRAYSIZE :
return "Array size is invalid. ";
	case DXFILEERR_BADCACHEFILE :
return "The cache file containing the X file date is invalid. A cache file contains data retrieved from the network, cached on the hard disk, and retrieved in subsequent requests. ";
	case DXFILEERR_BADDATAREFERENCE :
return "Data reference is invalid. ";
	case DXFILEERR_BADFILE :
return "File is invalid. ";
	case DXFILEERR_BADFILEFLOATSIZE :
return "Floating-point size is invalid. ";
	case DXFILEERR_BADFILETYPE :
return "File is not a DirectX file. ";
	case DXFILEERR_BADFILEVERSION :
return "File version is not valid. ";
	case DXFILEERR_BADRESOURCE :
return "Resource is invalid. ";
	case DXFILEERR_BADTYPE :
return "Object type is invalid. ";
	case DXFILEERR_BADVALUE :
return "Parameter is invalid. ";
	case DXFILEERR_FILENOTFOUND :
return "File could not be found. ";
	case DXFILEERR_NOMOREDATA :
return "No further data is available. ";
	case DXFILEERR_NOMOREOBJECTS :
return "All objects have been enumerated. ";
	case DXFILEERR_NOTFOUND :
return "Object could not be found. ";
	case DXFILEERR_PARSEERROR :
return "File could not be parsed. ";
	case DXFILEERR_RESOURCENOTFOUND :
		return "Resource could not be found. ";
	case DXFILEERR_URLNOTFOUND :
return "URL could not be found. ";
	default:
		return "no documented";
	}
}

hyp_NAMESPACE_END(dxfile)
hyp_NAMESPACE_END_HYPOUT

