/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Ephydryne Components.
 Ephydryne is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 27/03/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_out_facade_h_
#define _hyp_out_facade_h_


class CMeshData
{
public:
	CMeshData(hyp_ker::IUnknown*);
	struct SVertex {
		t_label label;	//label absolu du vertex
		t_real coord[3];
		bool dof[3];
		bool b_visible;
	};
	struct SVerticesEnum :
	public std::vector<SVertex>
	{

	};
	SVerticesEnum GetVerticesEnum(void);
	
	struct SBase {
		t_label label;
		t_label_enum vertices_global;	//vertices
		t_label_enum vertices_local;	//vertices en local		
	};

	template<class T>
	struct SBasesEnum :
	public std::vector<T> {
		int GetTotalRefNodes(void) {
			int TotalRef=0;
			for(int i=0;i<size();i++) {
				TotalRef+=at(i).vertices_global.size();
			}
			return TotalRef;
		}
	};
		
	struct SSide : public SBase { };
	struct SSidesEnum :
	public SBasesEnum<SSide> { };
	SSidesEnum GetSidesEnum(void);

	struct SElement : public SBase {
		t_real young;
		t_real poisson;
	};
	struct SElementsEnum :
	public SBasesEnum<SElement> { };
	SElementsEnum GetElementsEnum(void);

	t_label GetLabelVertex(hyp_ker::IUnknown*);
	t_label GetLabelSide(hyp_ker::IUnknown*);
	t_label GetLabelElement(hyp_ker::IUnknown*);

protected:
	t_label_enum GetLabelsForContainer(hyp_ker::IUnknown*,hyp_ker::IUnknown* =0);

private:
	hyp_fem::t_spGeometricBase m_spBaseMesh;
	hyp_fem::t_spGeometricObject m_spObjectMesh;
	hyp_fem::t_spFEOMesh m_spMeshMesh;	
	
};

#endif