/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#include"hyp.visual.intern.h"

hyp_NAMESPACE_BEGIN_HYPVISUAL

void _InvertBool(BOOL& b)
{
	b=( b==TRUE ? FALSE : TRUE);
}

//FIXTODO : trs moche
bool bDlgInit=true;	//si la boite de dialogue est en initialisation

BEGIN_MESSAGE_MAP(CForcesDialog, CDialog)
	//{{AFX_MSG_MAP(CForcesDialog)
	ON_BN_CLICKED(IDC_PONCTUALTYPE, OnSetPonctualType)
	ON_BN_CLICKED(IDC_PRESSIONTYPE, OnSetPressionType)
	ON_BN_CLICKED(IDC_ZONE_CHECK_1, OnSetZoneYZ)
	ON_BN_CLICKED(IDC_ZONE_CHECK_2, OnSetZoneXZ)
	ON_BN_CLICKED(IDC_ZONE_CHECK_3, OnSetZoneXY)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

t_real CForcesDialog::m_ForceX=0;
t_real CForcesDialog::m_ForceY=0;
t_real CForcesDialog::m_ForceZ=0;
BOOL CForcesDialog::m_InX=0;
BOOL CForcesDialog::m_InY=0;
BOOL CForcesDialog::m_InZ=0;
t_real CForcesDialog::m_l=0;
t_real CForcesDialog::m_L=0;
t_real CForcesDialog::m_O_1=0;
t_real CForcesDialog::m_O_2=0;
t_real CForcesDialog::m_RegionX=0;
t_real CForcesDialog::m_RegionY=0;
t_real CForcesDialog::m_RegionZ=0;
CForcesDialog::e_type_of_stress CForcesDialog::m_TypeOfStress=CForcesDialog::ponctual;


CForcesDialog::CForcesDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CForcesDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CForcesDialog)
	//}}AFX_DATA_INIT
}


void CForcesDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CForcesDialog)
	DDX_Text(pDX, IDC_ZONE_EDIT_1, m_RegionX);
	DDX_Text(pDX, IDC_ZONE_EDIT_2, m_RegionY);
	DDX_Text(pDX, IDC_ZONE_EDIT_3, m_RegionZ);
		
	DDX_Text(pDX, IDC_FORCE_X, m_ForceX);
	DDX_Text(pDX, IDC_FORCE_Y, m_ForceY);
	DDX_Text(pDX, IDC_FORCE_Z, m_ForceZ);

	DDX_Text(pDX, IDC_EXTRA_PRESSION_ZONE_EDIT_1, m_O_1);
	DDX_Text(pDX, IDC_EXTRA_PRESSION_ZONE_EDIT_2, m_O_2);
	DDX_Text(pDX, IDC_EXTRA_PRESSION_ZONE_EDIT_3, m_L);
	DDX_Text(pDX, IDC_EXTRA_PRESSION_ZONE_EDIT_4, m_l);
	//}}AFX_DATA_MAP
}

BOOL CForcesDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	bDlgInit=true;
	
	switch(m_TypeOfStress)
	{
	case ponctual:
		CheckDlgButton(IDC_PONCTUALTYPE,1);
		OnSetPonctualType();
		break;
	case pression:
		CheckDlgButton(IDC_PRESSIONTYPE,1);
		OnSetPressionType();
		break;
	default:
		hyp_ASSERT(0);		
	}

	ShowExtra();

	if(m_InX) CheckDlgButton(IDC_ZONE_CHECK_1,1);
	if(m_InY) CheckDlgButton(IDC_ZONE_CHECK_2,1);
	if(m_InZ) CheckDlgButton(IDC_ZONE_CHECK_3,1);

	SetReadOnlyEditControl(true);

	bDlgInit=false;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CForcesDialog::OnSetPonctualType()
{
	m_TypeOfStress=ponctual;
	ShowExtra();
}

void CForcesDialog::OnSetPressionType()
{
	m_TypeOfStress=pression;

	reinterpret_cast<CButton*>(GetDlgItem(IDC_ZONE_CHECK_1))->SetCheck(0);
	reinterpret_cast<CButton*>(GetDlgItem(IDC_ZONE_CHECK_2))->SetCheck(0);
	reinterpret_cast<CButton*>(GetDlgItem(IDC_ZONE_CHECK_3))->SetCheck(0);
	if(!bDlgInit) m_InX=m_InY=m_InZ=0;


	ShowExtra();
}

void CForcesDialog::OnSetZoneYZ()
{
	if(m_TypeOfStress==pression) {
		m_InX=TRUE;
		m_InY=FALSE;
		m_InZ=FALSE;
	} else {
		_InvertBool(m_InX);
	}
	SetReadOnlyEditControl(true);
}

void CForcesDialog::OnSetZoneXZ()
{
	if(m_TypeOfStress==pression) {
		m_InX=FALSE;
		m_InY=TRUE;
		m_InZ=FALSE;	
	} else {
		_InvertBool(m_InY);
	}
	SetReadOnlyEditControl(true);
}

void CForcesDialog::OnSetZoneXY()
{
	if(m_TypeOfStress==pression) {
		m_InX=FALSE;
		m_InY=FALSE;
		m_InZ=TRUE;
	} else {
		_InvertBool(m_InZ);
	}
	SetReadOnlyEditControl(true);
}

void CForcesDialog::SetReadOnlyEditControl(bool b)
{
	reinterpret_cast<CEdit*>(GetDlgItem(IDC_ZONE_EDIT_1))->SetReadOnly(b && m_InX==false);
	reinterpret_cast<CEdit*>(GetDlgItem(IDC_ZONE_EDIT_2))->SetReadOnly(b && m_InY==false);
	reinterpret_cast<CEdit*>(GetDlgItem(IDC_ZONE_EDIT_3))->SetReadOnly(b && m_InZ==false);
}

void CForcesDialog::ShowExtra(void)
{
	ShowExtraPonctual(m_TypeOfStress==ponctual);
	ShowExtraPression(m_TypeOfStress==pression);
}

void CForcesDialog::ShowExtraPonctual(bool bShow)
{
	int param=bShow ? SW_SHOW : SW_HIDE;
/*	
	GetDlgItem(IDC_ZONE_CHECK_1)->ShowWindow(param);
	GetDlgItem(IDC_ZONE_CHECK_2)->ShowWindow(param);
	GetDlgItem(IDC_ZONE_CHECK_3)->ShowWindow(param);
*/	
/*	GetDlgItem(IDC_ZONE_COMMENT_1)->ShowWindow(param);
	GetDlgItem(IDC_ZONE_EDIT_1)->ShowWindow(param);
	GetDlgItem(IDC_ZONE_COMMENT_2)->ShowWindow(param);
	GetDlgItem(IDC_ZONE_EDIT_2)->ShowWindow(param);
	GetDlgItem(IDC_ZONE_COMMENT_3)->ShowWindow(param);
	GetDlgItem(IDC_ZONE_EDIT_3)->ShowWindow(param);
	*/
}

void CForcesDialog::ShowExtraPression(bool bShow)
{
	int param=bShow ? SW_SHOW : SW_HIDE;
	int style=bShow ? BS_AUTORADIOBUTTON : BS_AUTOCHECKBOX;
	
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_TITLE)->ShowWindow(param);
	
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_COMMENT_1)->ShowWindow(param);
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_EDIT_1)->ShowWindow(param);
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_EDIT_2)->ShowWindow(param);
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_COMMENT_2)->ShowWindow(param);
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_EDIT_3)->ShowWindow(param);
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_COMMENT_3)->ShowWindow(param);
	GetDlgItem(IDC_EXTRA_PRESSION_ZONE_EDIT_4)->ShowWindow(param);

	reinterpret_cast<CButton*>(GetDlgItem(IDC_ZONE_CHECK_1))->SetButtonStyle(style);
	reinterpret_cast<CButton*>(GetDlgItem(IDC_ZONE_CHECK_2))->SetButtonStyle(style);
	reinterpret_cast<CButton*>(GetDlgItem(IDC_ZONE_CHECK_3))->SetButtonStyle(style);

	SetReadOnlyEditControl(true);	
}


hyp_NAMESPACE_END_HYPVISUAL
