/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#ifndef _hyp_dialog_forces_h_
#define _hyp_dialog_forces_h_


class CForcesDialog : public CDialog
{
public:
	CForcesDialog(CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CForcesDialog)
	enum { IDD = IDD_FORCE };
	
	static t_real m_RegionX;
	static t_real m_RegionY;
	static t_real m_RegionZ;	
	static BOOL	m_InX;
	static BOOL	m_InY;
	static BOOL	m_InZ;

	static t_real m_ForceX;
	static t_real m_ForceY;
	static t_real m_ForceZ;

	static t_real m_O_1;
	static t_real m_O_2;
	static t_real m_L;
	static t_real m_l;
	//}}AFX_DATA
	enum e_type_of_stress {
		ponctual,
		pression
	};
	static e_type_of_stress m_TypeOfStress;



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CForcesDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg void OnSetPonctualType();
	afx_msg void OnSetPressionType();
	afx_msg void OnSetZoneYZ();
	afx_msg void OnSetZoneXZ();
	afx_msg void OnSetZoneXY();
	//}}AFX_VIRTUAL

// Implementation
protected:
	void ShowExtraPonctual(bool);
	void ShowExtraPression(bool);
	void ShowExtra(void);
	void SetReadOnlyEditControl(bool);

	// Generated message map functions
	//{{AFX_MSG(CForcesDialog)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif
