/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#include"hyp.visual.intern.h"


hyp_NAMESPACE_BEGIN_HYPVISUAL


BEGIN_MESSAGE_MAP(COptionsDialog, CDialog)
	//{{AFX_MSG_MAP(COptionsDialog)
	ON_BN_CLICKED(IDC_FILLMODE_POINTS, OnFillModePoints)
	ON_BN_CLICKED(IDC_FILLMODE_WIREFRAME, OnFillModeWireframe)
	ON_BN_CLICKED(IDC_FILLMODE_SOLID, OnFillModeSolid)
	ON_BN_CLICKED(IDC_APPLY_FIXED_COLOR, OnCheckApplyFixedColor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


COptionsDialog::COptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDialog)
	//}}AFX_DATA_INIT
}


void COptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);		
	//{{AFX_DATA_MAP(COptionsDialog)
	DDX_Text(pDX, IDC_COLOR_R, m_Color.m_R);
	DDV_MinMaxFloat(pDX,m_Color.m_R,0.0f,1.0f);	
	DDX_Text(pDX, IDC_COLOR_G, m_Color.m_G);
	DDV_MinMaxFloat(pDX,m_Color.m_G,0.0f,1.0f);	
	DDX_Text(pDX, IDC_COLOR_B, m_Color.m_B);
	DDV_MinMaxFloat(pDX,m_Color.m_B,0.0f,1.0f);

	DDX_Text(pDX, IDC_COLOR_R_FIXED, m_ColorFixed.m_R);
	DDV_MinMaxFloat(pDX,m_ColorFixed.m_R,0.0f,1.0f);	
	DDX_Text(pDX, IDC_COLOR_G_FIXED, m_ColorFixed.m_G);
	DDV_MinMaxFloat(pDX,m_ColorFixed.m_G,0.0f,1.0f);	
	DDX_Text(pDX, IDC_COLOR_B_FIXED, m_ColorFixed.m_B);
	DDV_MinMaxFloat(pDX,m_ColorFixed.m_B,0.0f,1.0f);

	DDX_Check(pDX, IDC_CHECK1, m_bShowAxes);	
	//}}AFX_DATA_MAP
}


void COptionsDialog::OnFillModePoints() 
{
	m_FillMode=D3DRMFILL_POINTS;	
}
void COptionsDialog::OnFillModeWireframe() 
{
	m_FillMode=D3DRMFILL_WIREFRAME;	
}
void COptionsDialog::OnFillModeSolid() 
{
	m_FillMode=D3DRMFILL_SOLID;	
}

BOOL COptionsDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	switch(m_FillMode)
	{
	case D3DRMFILL_POINTS:
		CheckDlgButton(IDC_FILLMODE_POINTS,1);
		break;
	case D3DRMFILL_WIREFRAME:
		CheckDlgButton(IDC_FILLMODE_WIREFRAME,1);
		break;
	case D3DRMFILL_SOLID:default:
		CheckDlgButton(IDC_FILLMODE_SOLID,1);
		break;
	}

	int style=0;
	if(m_ApplyFixedColor) style=1;
	reinterpret_cast<CButton*>(GetDlgItem(IDC_APPLY_FIXED_COLOR))->SetCheck(style);
	UpdateFixedColorEdit();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsDialog::OnCheckApplyFixedColor()
{
	m_ApplyFixedColor=m_ApplyFixedColor ? false : true;
	UpdateFixedColorEdit();
}

void COptionsDialog::UpdateFixedColorEdit(void)
{
	reinterpret_cast<CEdit*>(GetDlgItem(IDC_COLOR_R_FIXED))->SetReadOnly(m_ApplyFixedColor==FALSE);
	reinterpret_cast<CEdit*>(GetDlgItem(IDC_COLOR_G_FIXED))->SetReadOnly(m_ApplyFixedColor==FALSE);
	reinterpret_cast<CEdit*>(GetDlgItem(IDC_COLOR_B_FIXED))->SetReadOnly(m_ApplyFixedColor==FALSE);
}

hyp_NAMESPACE_END_HYPVISUAL





