/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#include"hyp.visual.intern.h"

hyp_NAMESPACE_BEGIN_HYPVISUAL



CShowDialog::CShowDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CShowDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShowDialog)
	m_Show = _T("");
	//}}AFX_DATA_INIT
}


void CShowDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShowDialog)
	DDX_Text(pDX, IDC_EDIT, m_Show);
	//}}AFX_DATA_MAP
}

void CShowDialog::InitFileBuffer(e_show show_option,hyp_ker::IUnknown* pUnknownMesh)
{
	CWaitCursor wait;
	
	hyp_out::t_spShowMeshObject spShow;
	spShow.CreateInstance(hyp_out::CLSID_hypCObjectStdFile,0);
	
	std::stringstream str_stream;
	spShow->SetOutput(str_stream);
	spShow->SetObject(pUnknownMesh);	
	
	switch(show_option) {
	case show_nodes:
		spShow->ShowNodes();
		break;
	case show_sides:
		spShow->ShowSides();
		break;
	case show_elements:
		spShow->ShowElements();
		break;
	case show_matrix:
		spShow->ShowMatrixDim();
		str_stream<<"\nOpen the file to see the complete matrix...\n";
		break;
	case show_forcemask:
		spShow->ShowForceMask();
		break;
	case show_rendermask:
		spShow->ShowRenderMask();
		break;
	case show_local_displacements:
		spShow->ShowDisplacements();
		break;
	case show_global_displacements:
		spShow->ShowGlobalDisplacements();
		break;
	case show_local_forces:
		spShow->ShowForces();
		break;
	case show_global_forces:
		spShow->ShowGlobalForces();
		break;	
	default:
		hyp_ASSERT(0);
	}	

	char buff=0;
	std::string str;
	while(str_stream.get(buff)) {
		if(buff=='\n')	str+='\r';
		str+=buff;
	}
	
	m_Show=CString(str.c_str());

	spShow->CloseOutput();

}


BEGIN_MESSAGE_MAP(CShowDialog, CDialog)
	//{{AFX_MSG_MAP(CShowDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShowDialog message handlers

BOOL CShowDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//FIXTODO : enlever la selection de la boite
	//reinterpret_cast<CEdit*>(GetDlgItem(IDC_EDIT))->SetSel(10,20,TRUE);
		
	return TRUE;
}



hyp_NAMESPACE_END_HYPVISUAL



