/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_visual_doc_h_
#define _hyp_visual_doc_h_


class CHypVisualDoc : public CDocument
{
protected:
	CHypVisualDoc();
	DECLARE_DYNCREATE(CHypVisualDoc)

// Attributes
public:
	hyp_ker::IPtrUnknown m_spUnknownMesh;
	hyp_fem::t_spGeometricBase m_spBaseMesh;
	hyp_fem::t_spGeometricObject m_spObjectMesh;
	hyp_fem::t_spFEOMesh m_spMeshMesh;	


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHypVisualDoc)
	public:
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHypVisualDoc();

	void CreateMesh(void);
	void InitMesh(hyp_ker::IUnknown*);

	void GetXFileName(std::string&);


// Generated message map functions
protected:
	//{{AFX_MSG(CHypVisualDoc)
	afx_msg void OnShowMatrix();
	afx_msg void OnSetForces();
	afx_msg void OnClearForces();
	afx_msg void OnShowNodes();
	afx_msg void OnShowSides();
	afx_msg void OnShowElements();
	afx_msg void OnShowRenderMask();
	afx_msg void OnShowForceMask();
	afx_msg void OnShowDisplacements();
	afx_msg void OnShowGlobalDisplacements();
	afx_msg void OnShowForces();
	afx_msg void OnShowGlobalForces();
	afx_msg void OnFileSaveAs();
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif
