/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
 
 Creation 22/04/01 Pierre Rebours
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_visual_intern_h_
#define _hyp_visual_intern_h_


#define ID_UPDATE_STATUSBAR 20

#include<d3drmwin.h>
#undef _WINDOWS_

#define hyp_NO_INCLUDE_WIN32_HEADER
#include"hyp.visual.stdafx.h"

#include"hyp.fem.h"
#include"hyp.out.h"



#include "hyp.visual.resource.h"
#include"rmerror.h"

#define hyp_NAMESPACE_BEGIN_HYPVISUAL hyp_NAMESPACE_BEGIN_HYP \
										hyp_NAMESPACE_BEGIN(hypvisual)
#define hyp_NAMESPACE_END_HYPVISUAL hyp_NAMESPACE_END_HYP \
										hyp_NAMESPACE_END(hypvisual)

#define hyp_CHECK_HR( hr ) if(FAILED(hr)) hyp_NOTIFY( ("DirectX Error") );

#define SAFE_RELEASE(x) if (x != NULL) {x->Release(); x = NULL;}


//FIXTODO : macro au niveau global de hypker...
#define hyp_CATCH_ITOR  catch(hyp_ker::CComException error) {				\
							if(hyp_ker::Failed(error.GetResult())) {	\
								throw error;							\
							}											\
						}


hyp_NAMESPACE_BEGIN_HYPVISUAL

struct Color {
	typedef D3DVALUE t_ColorComponent;
	t_ColorComponent m_R;
	t_ColorComponent m_G;
	t_ColorComponent m_B;

	Color& operator=(const Color& color) {
		m_R=color.m_R;
		m_G=color.m_G;
		m_B=color.m_B;
		return *this;
	}
	Color(t_ColorComponent R,t_ColorComponent G,t_ColorComponent B) :
	m_R(R),m_G(G),m_B(B)
	{ }
	Color() :
	m_R(0),m_G(0),m_B(0)
	{
	}

	D3DCOLOR GetColorRGB(void) {
		return D3DRMCreateColorRGB(m_R,m_G,m_B);
	}
};

std::string GetLocalPath(const std::string&);

#include"hyp.visual.winmain.h"
#include"hyp.visual.doc.h"
#include"hyp.visual.mainfrm.h"

#include"hyp.visual.tool.h"
#include"hyp.visual.view.h"

#include "hyp.dialog.options.h"
#include "hyp.dialog.show.h"
#include "hyp.dialog.forces.h"
#include "hyp.dialog.viscosity.h"

hyp_NAMESPACE_END_HYPVISUAL


#endif

