/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#include "hyp.visual.intern.h"

hyp_NAMESPACE_BEGIN_HYPVISUAL

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CMainFrame::CMainFrame()
{
	
}

CMainFrame::~CMainFrame()
{

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
#if 0
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

#endif

	CreateStatusBar();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	cs.lpszClass=::AfxRegisterWndClass(0,
		::AfxGetApp()->LoadStandardCursor(IDC_CROSS),
		(HBRUSH) (COLOR_WINDOW+1),
		::AfxGetApp()->LoadIcon(IDI_HYPERION));

	cs.cx=500;
	cs.cy=500;
	cs.x=0;
	cs.y=0;

	cs.lpszName="HypVisual";

	return TRUE;
}

bool CMainFrame::CreateStatusBar(void)
{
	m_wndStatusBar.Create(this);

	UINT nIndicators[] = {
		ID_SEPARATOR,
		ID_SEPARATOR,
		ID_SEPARATOR		
	};
	
	m_wndStatusBar.SetIndicators(nIndicators,sizeof(nIndicators)/sizeof(nIndicators[0]));
	
	m_wndStatusBar.SetPaneInfo(0,nIndicators[0],SBPS_NOBORDERS|SBPS_STRETCH,0);
	m_wndStatusBar.SetPaneInfo(1,nIndicators[1],SBPS_NORMAL,50);
	m_wndStatusBar.SetPaneInfo(2,nIndicators[2],SBPS_NORMAL,50);	

	return true;
}


void CMainFrame::ShowIsRotated(bool bRot)
{
	bRot ? m_wndStatusBar.SetPaneText(1,"ROT") : m_wndStatusBar.SetPaneText(1,"");
}

void CMainFrame::ShowIsDeformed(bool bDef)
{
	hyp_ASSERT(0);
	bDef ? m_wndStatusBar.SetPaneText(3,"DEFORM") : m_wndStatusBar.SetPaneText(2,"NO DEFORM");
}

void CMainFrame::ShowPlayState(void)
{
	m_wndStatusBar.SetPaneText(2,"PLAY");
}

void CMainFrame::ShowStopState(void)
{
	m_wndStatusBar.SetPaneText(2,"STOP");
}

void CMainFrame::ShowPauseState(void)
{
	m_wndStatusBar.SetPaneText(2,"PAUSE");
}

hyp_NAMESPACE_END_HYPVISUAL
