/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 HypVisual.
 HypVisual is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#ifndef _hyp_visual_view_h_
#define _hyp_visual_view_h_




class CHypVisualView : public CView
{
protected:
	
	//{{AFX_MSG(CHypVisualView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnOptionsDialogShow();
	afx_msg void OnSetViscosity();
	afx_msg void OnSimulationBegin();
	afx_msg void OnResetPosition();
	afx_msg void OnSimulationStop();
	afx_msg void OnUpdateSimulationStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSimulationBegin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSetForces(CCmdUI* pCmdUI);
	afx_msg void OnUpdateClearForces(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSetViscosity(CCmdUI* pCmdUI);
	
	afx_msg void OnReorientMesh();
	afx_msg void OnUpdateStatusBar();

	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:	


private:
	
	CRotationTool m_Rotation;
	CRenderTool m_Render;
	CSimulationTool m_Simulation;
	
	struct Param {
		D3DVALUE DeplacDiff;
		D3DVALUE RotationDiff;


	} m_Param;

	inline CMainFrame* GetFrame(void) {
		return (CMainFrame*)(::AfxGetApp()->m_pMainWnd);
	}	

protected: // create from serialization only
	CHypVisualView();
	DECLARE_DYNCREATE(CHypVisualView)

// Attributes
public:
	inline CHypVisualDoc* GetDocument() {
		return (CHypVisualDoc*)m_pDocument;
	}

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHypDevView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual LRESULT DefWindowProc( UINT message, WPARAM wParam, LPARAM lParam ); 
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHypVisualView();

	friend class CTool;


};



//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.






#endif
